<?php
/*
	Newsletter - GuppY PHP Script - version 4.6
	CeCILL Copyright (C) 2004-2007 by Laurent Duveau
	Initiated by Laurent Duveau and Nicolas Alves
	  Web site = http://www.freeguppy.org/
	  e-mail   = info@freeguppy.org

	Version History :
	  v3.0 (25 February 2004)     : initial release by Nicolas Alves and Laurent Duveau
	  v3.0p1 (26 Feb 2004)        : ergonomic fixes in the e-mails sent when a user subscribes to the newsletter
	  v4.0 (06 December 2004)     : added page title (by Jean-Mi)
	  v4.6.0 (04 June 2007)       : updated email checking (by Icare)
									corrected function IsValidMail (by djchouix and hpsam)
									corrected bad remove (by hpsam)
	  v4.6.2 (22 July 2007)       : new function isValidMail() (by Icare)
	  v4.6.3 (30 August 2007)     : test email server become optionnal (by Icare)
*/

header("Pragma: no-cache");
define("CHEMIN", "");
// Added cryptographp ==>
$cryptinstall = CHEMIN.'plugins/cryptographp/cryptographp.fct.php';
$crypterror = false;
include_once $cryptinstall;
// <== cryptographp
include("inc/includes.inc");
// Added / Modified cryptographp ==>
include_once(CHEMIN.'plugins/cryptographp/inc/function.inc');
if ($serviz[36] != "on" && $cp_cfg[6] != "on") {
  exit($web143);
}
// <== cryptographp
if (import('action', 'GET') != NULL && $_GET['action'] == 'sub')  die('STOP ! Variable $action: illegal origine !');
if (!isset($nlpseudo)) {
  header("location:index.php?lng=".$lng);
}

function isValidEmail($email, $sender, $domainCheck, $verify = true, $return_errors=true) {
	global $debug;
	$error = "";
	if($debug) {echo "<pre>";}
	# Check syntax with regex
	if (preg_match('/^([a-zA-Z0-9\._\+-]+)\@((\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,7}|[0-9]{1,3})(\]?))$/', $email, $matches)) {
	  $user = $matches[1];
	  $domain = $matches[2];
	  $ipname = gethostbyname($domain);
	  if ($ipname == $domain) {
		$error = "Domaine inconnu - No such a domain";
	  }
	  elseif ($domainCheck =="on") {
		# Check availability of DNS MX records
		if (function_exists('checkdnsrr')) {
			echo "checking server...<br />";
			# Construct array of available mailservers
			if(getmxrr($domain, $mxhosts, $mxweight)) {
				for($i=0;$i<count($mxhosts);$i++){
					$mxs[$mxhosts[$i]] = $mxweight[$i];
				}
				asort($mxs);
				$mailers = array_keys($mxs);
			} elseif(checkdnsrr($domain, 'A')) {
				$mailers[0] = gethostbyname($domain);
			} else {
				$mailers=array();
			}
			$total = count($mailers);
			# Query each mailserver
			if($total > 0 && $verify) {
				# Check if mailers accept mail
				for($n=0; $n < $total; $n++) {
					# Check if socket can be opened
					if($debug) { echo "Checking server $mailers[$n]...\n";}
					$connect_timeout = 2;
					$errno = 0;
					$errstr = 0;
					$probe_address = $sender;
					# Try to open up socket
					if($sock = @fsockopen($mailers[$n], 25, $errno , $errstr, $connect_timeout)) {
						$response = fgets($sock);
						if($debug) {echo "Opening up socket to $mailers[$n]... Succes!\n";}
						stream_set_timeout($sock, 5);
						$meta = stream_get_meta_data($sock);
						if($debug) { echo "$mailers[$n] replied: $response\n";}
						$cmds = array(
							"HELO ".$_SERVER['HTTP_HOST'],  # Be sure to set this correctly!
							"MAIL FROM: <$probe_address>",
							"RCPT TO: <$email>",
							"QUIT",
						);
						# Hard error on connect -> break out
						if(!$meta['timed_out'] && !preg_match('/^2\d\d[ -]/', $response)) {
							$error = "Error: $mailers[$n] said: $response\n";
							break;
						}
						foreach($cmds as $cmd) {
							$before = microtime(true);
							fputs($sock, "$cmd\r\n");
							$response = fgets($sock, 4096);
							$t = 1000*(microtime(true)-$before);
							if($debug) {echo htmlentities("$cmd\n$response") . "(" . sprintf('%.2f', $t) . " ms)\n";}
							if(!$meta['timed_out'] && preg_match('/^5\d\d[ -]/', $response)) {
								$error = "Adresse rejet par le serveur - Server rejected address";
								break 2;
							}
						}
						fclose($sock);
						if($debug) { echo "Succesful communication with $mailers[$n], no hard errors, assuming OK";}
						$error = "";
						break;
					} elseif($n == $total-1) {
						$error = "Pas de rponse du server - No response from server";
					}
				}
			} elseif($total <= 0) {
				$error = "Pas de connexion au serveur - No connection to the server";
			}
		}
		else {
		$error = '';
		}
	  }
	} else {
		$error = 'Email est mal form - Email is not properly formatted';
	}
	if($debug) { echo "</pre>";}
	if($return_errors) {
		if(isset($error)) return htmlentities($error); else return true;
	}
}

if (eregi('^(http|ftp|Votre|Your)', $nlpseudo)) die('STOP ! illegal pseudo');
$topmess = $web222;
include("inc/hpage.inc");
htable($web222, "100%");
// cryptographp ==>
if ((chk_crypt($_POST['cryptcodenl']) || ($userprefs[1] != '' && $cp_cfg[12])) || $action == "unsub") {
// <== cryptographp

if ($action == "sub") {
  $nlpseudo = KeepGoodChars(CutLongWord(strip_tags(stripslashes($nlpseudo)),20));
  $nlmail = strip_tags(stripslashes($nlmail));
  echo "<p style='text-align:left'>Checking &nbsp;".$nlmail." ...<br /><br /></p>";
  $error = "";
  if(($nlpseudo == "") or ($nlpseudo == KeepGoodChars($web259))) {
	$error = '<p align="justify"> - '.$web252.'</p>';
  }
  if ((!ereg("^(.+)@(.+)\\.(.+)$",$nlmail)) || ($nlmail == "") || ($nlmail == $web260)) {
	$error .= "<p align=\"justify\"> - ".$web251."</p>";
  }
  if ($error == "") {
	$controle = CheckDB1Field(DBNEWSLETTER,$nlpseudo,0);
	if ($controle) {
	$error = $web405;
	}
	else{
	  $controle = CheckDB1Field(DBNEWSLETTER,$nlmail,1);
	  if ($controle) {
		$error = $web250;
	  }
	}
	if (!$controle) {
	  $valemail = IsValidEmail($nlmail, $user[1], $serviz[36]);
	  if ($valemail) {
		$controle = false;
		$error = $valemail;
	  }
	}
	if (!$controle && !$valemail) {
	  echo '<p>'.$web249.'<b> '.$nlpseudo.'</b><br /><br />'.$web50.'<b> '.$nlmail.'</b> '.$web248.'</p><br />';
	  $nllist = array();
	  $nllist[0] = $nlpseudo;
	  $nllist[1] = $nlmail;
	  $nllist[2] = $lng;
	  AppendDBFields(DBNEWSLETTER,$nllist);
	  if ($supervision[7] == "on") {
		$to = $nlmail;
		$sujet = $site[0]." - ".$web246;
		$body  = $web245." ".$nlpseudo.$web244." ".$site[0]."<hr />";
		$body .= $web235."<br />".$user[0]."<br />".$site[3]."<hr />";
		$body .= $web243."<br />";
		$body .= '<a href="'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'">'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'</a>';
		eMailHtmlTo($sujet,$body,$to);
		$body  = $nlpseudo.' ('.$nlmail.') '.$web242.' '.$site[0]."<hr />";
		$body .= $web241.":<br />";
		$body .= '<a href="'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'">'.$site[3].'newsletter.php?lng='.$lng.'&action=unsub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'</a>';
		eMailHtmlTo($sujet,$body,"");
	  }
	}
	else {
	  echo '<br /><p>'.$error.'</p><br />';
	}
  }
  else {
	echo '<p align="justify"><b>'.$web256.'</b></p><br />'.$error;
  }
 }
 elseif ($action == "unsub") {
  $error = "";
  if (($nlpseudo == "") || ($nlpseudo == KeepGoodChars($web259))) {
	$error = '<p align="justify"> - '.$web252.'</p>';
  }
  if ((!ereg("^(.+)@(.+)\\.(.+)$",$nlmail)) || ($nlmail == "") || ($nlmail == $web260)) {
	$error .= '<p align="justify"> - '.$web251.'</p>';
  }
  if ($error == "") {
	$controle = CheckDB2Fields(DBNEWSLETTER,$nlpseudo,0,$nlmail,1);
	if ($controle) {
	  $nlpseudo = stripslashes($nlpseudo);
	  $newdb = array();
	  $dbwork = ReadDBFields(DBNEWSLETTER);
	  for ($i = 0; $i < count($dbwork); $i++) {
		if ($dbwork[$i][1] == $nlmail) {
		  if ($dbwork[$i][0] != $nlpseudo)
			  $newdb[] = $dbwork[$i];
		}
		else {
			$newdb[] = $dbwork[$i];
		}
	  }
	  WriteDBFields(DBNEWSLETTER,$newdb);
	  echo '<p>'.$web253.'<b> '.$nlpseudo.'</b><br /><br />'.$web255.'<b> '.$nlmail.'</b> '.$web254.'</p><br />';
	  if ($supervision[7] == "on") {
		$to = $nlmail;
		$sujet  = $site[0]." - ".$web241;
		$body  = $web240." ".$nlpseudo.$web239." ".$site[0]."<hr />";
		$body .= $web235."<br />".$user[0]."<br />".$site[3]."<hr />";
		$body .= $web234."<br />";
		$body .= '<a href="'.$site[3].'newsletter.php?lng='.$lng.'&;action=sub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'">'.$site[3].'newsletter.php?lng='.$lng.'&;action=sub&nlpseudo='.$nlpseudo.'&nlmail='.$nlmail.'</a>';
		eMailHtmlTo($sujet,$body,$to);
		$body  = $nlpseudo." (".$nlmail.") ".$web238." ".$site[0]."\n";
		eMailHtmlTo($sujet,$body,"");
	  }
	}
	else {
	  echo '<br /><p>'.$web255.'<b>'.$nlmail.'</b>'.$web233.'</p><br />';
	}
  }
  else {
	echo '<p align="justify"><b>'.$web256.'</b></p><br />'.$error;
  }
}
// cryptographp ==>
}
else {
	echo '<div align="center" style="color:red; background-color:yellow; border:1px solid red; font-weight:bold;">'.$cp_web1.'</div>';
}
// <== cryptographp
btable();
include("inc/bpage.inc");
?>